/** \file graph.cpp
 * 
 * Function definitions for the class graph.
 * 
 */

#ifndef GRAPH_HPP_
#define GRAPH_HPP_

/*********************************************** includes ***********************************/

// include config.h
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

// STL headers
#include <deque>
#include <map>

/****************************************** forward declarations *****************************/

/********************************************** definitions *********************************/

typedef std::pair < int, class Node* > NodeMap;
typedef std::multimap < class Node*, class Edge* > EdgeMap;

typedef std::deque<int> KeyStack;

#endif /*GRAPH_HPP_*/
